/*
 * orig: sys/bsd/spawn.c
 */

#include	"def.h"

#include	<signal.h>

char	*shellp = NULL;			/* Saved "SHELL" name.		*/

extern	char	*getenv();
extern  char    **envptr;

/*ARGSUSED*/
spawncli(f, n) {
	register int	pid, wpid, (*oqsig)(), (*oisig)();
	int	status;

	if (shellp == NULL) {
		shellp = getenv("SHELL");
		if (shellp == NULL)
			shellp = getenv("shell");
		if (shellp == NULL)
			shellp = "/bin/sh";	/* Safer.		*/
	}
	ttcolor(CTEXT);
	ttnowindow();
	ttmove(nrow-1, 0);
	if (epresf != FALSE) {
		tteeol();
		epresf = FALSE;
	}

	if (ttcooked() == FALSE)
		return (FALSE);

	oqsig = signal(SIGQUIT, SIG_IGN);
	oisig = signal(SIGINT,	SIG_IGN);
	if ((pid=fork()) < 0) {
		(void) signal(SIGQUIT, oqsig);
		(void) signal(SIGINT,  oisig);
		ewprintf("Failed to create process");
		ttraw();
		return (FALSE);
	}
	if (pid == 0) {
		execle(shellp, "sh", "-i", (char *)NULL, envptr);
		exit(0);		/* Should do better!	*/
	}
	while ((wpid=wait(&status))>=0 && wpid!=pid)
		;
	(void) signal(SIGQUIT, oqsig);
	(void) signal(SIGINT,  oisig);

	sgarbf = TRUE;				/* Force repaint.	*/
	return ttraw();
}
